git-am.shon commit send-email: Remove superfluous `my $editor = ...' (bec99cf)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5SUBDIRECTORY_OK=Yes
   6OPTIONS_KEEPDASHDASH=
   7OPTIONS_SPEC="\
   8git am [options] [<mbox>|<Maildir>...]
   9git am [options] (--resolved | --skip | --abort)
  10--
  11i,interactive   run interactively
  12b,binary*       (historical option -- no-op)
  133,3way          allow fall back on 3way merging if needed
  14s,signoff       add a Signed-off-by line to the commit message
  15u,utf8          recode into utf8 (default)
  16k,keep          pass -k flag to git-mailinfo
  17whitespace=     pass it through git-apply
  18directory=      pass it through git-apply
  19C=              pass it through git-apply
  20p=              pass it through git-apply
  21reject          pass it through git-apply
  22resolvemsg=     override error message when patch failure occurs
  23r,resolved      to be used after a patch failure
  24skip            skip the current patch
  25abort           restore the original branch and abort the patching operation.
  26committer-date-is-author-date    lie about committer date
  27ignore-date     use current timestamp for author date
  28rebasing*       (internal use for git-rebase)"
  29
  30. git-sh-setup
  31prefix=$(git rev-parse --show-prefix)
  32set_reflog_action am
  33require_work_tree
  34cd_to_toplevel
  35
  36git var GIT_COMMITTER_IDENT >/dev/null ||
  37        die "You need to set your committer info first"
  38
  39sq () {
  40        for sqarg
  41        do
  42                printf "%s" "$sqarg" |
  43                sed -e 's/'\''/'\''\\'\'''\''/g' -e 's/.*/ '\''&'\''/'
  44        done
  45}
  46
  47stop_here () {
  48    echo "$1" >"$dotest/next"
  49    exit 1
  50}
  51
  52stop_here_user_resolve () {
  53    if [ -n "$resolvemsg" ]; then
  54            printf '%s\n' "$resolvemsg"
  55            stop_here $1
  56    fi
  57    cmdline="git am"
  58    if test '' != "$interactive"
  59    then
  60        cmdline="$cmdline -i"
  61    fi
  62    if test '' != "$threeway"
  63    then
  64        cmdline="$cmdline -3"
  65    fi
  66    echo "When you have resolved this problem run \"$cmdline --resolved\"."
  67    echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
  68    echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
  69
  70    stop_here $1
  71}
  72
  73go_next () {
  74        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
  75                "$dotest/patch" "$dotest/info"
  76        echo "$next" >"$dotest/next"
  77        this=$next
  78}
  79
  80cannot_fallback () {
  81        echo "$1"
  82        echo "Cannot fall back to three-way merge."
  83        exit 1
  84}
  85
  86fall_back_3way () {
  87    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
  88
  89    rm -fr "$dotest"/patch-merge-*
  90    mkdir "$dotest/patch-merge-tmp-dir"
  91
  92    # First see if the patch records the index info that we can use.
  93    git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
  94        "$dotest/patch" &&
  95    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
  96    git write-tree >"$dotest/patch-merge-base+" ||
  97    cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
  98
  99    echo Using index info to reconstruct a base tree...
 100    if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 101        git apply --cached <"$dotest/patch"
 102    then
 103        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
 104        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
 105    else
 106        cannot_fallback "Did you hand edit your patch?
 107It does not apply to blobs recorded in its index."
 108    fi
 109
 110    test -f "$dotest/patch-merge-index" &&
 111    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
 112    orig_tree=$(cat "$dotest/patch-merge-base") &&
 113    rm -fr "$dotest"/patch-merge-* || exit 1
 114
 115    echo Falling back to patching base and 3-way merge...
 116
 117    # This is not so wrong.  Depending on which base we picked,
 118    # orig_tree may be wildly different from ours, but his_tree
 119    # has the same set of wildly different changes in parts the
 120    # patch did not touch, so recursive ends up canceling them,
 121    # saying that we reverted all those changes.
 122
 123    eval GITHEAD_$his_tree='"$FIRSTLINE"'
 124    export GITHEAD_$his_tree
 125    git-merge-recursive $orig_tree -- HEAD $his_tree || {
 126            git rerere
 127            echo Failed to merge in the changes.
 128            exit 1
 129    }
 130    unset GITHEAD_$his_tree
 131}
 132
 133prec=4
 134dotest="$GIT_DIR/rebase-apply"
 135sign= utf8=t keep= skip= interactive= resolved= rebasing= abort=
 136resolvemsg= resume=
 137git_apply_opt=
 138committer_date_is_author_date=
 139ignore_date=
 140
 141while test $# != 0
 142do
 143        case "$1" in
 144        -i|--interactive)
 145                interactive=t ;;
 146        -b|--binary)
 147                : ;;
 148        -3|--3way)
 149                threeway=t ;;
 150        -s|--signoff)
 151                sign=t ;;
 152        -u|--utf8)
 153                utf8=t ;; # this is now default
 154        --no-utf8)
 155                utf8= ;;
 156        -k|--keep)
 157                keep=t ;;
 158        -r|--resolved)
 159                resolved=t ;;
 160        --skip)
 161                skip=t ;;
 162        --abort)
 163                abort=t ;;
 164        --rebasing)
 165                rebasing=t threeway=t keep=t ;;
 166        -d|--dotest)
 167                die "-d option is no longer supported.  Do not use."
 168                ;;
 169        --resolvemsg)
 170                shift; resolvemsg=$1 ;;
 171        --whitespace|--directory)
 172                git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
 173        -C|-p)
 174                git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
 175        --reject)
 176                git_apply_opt="$git_apply_opt $1" ;;
 177        --committer-date-is-author-date)
 178                committer_date_is_author_date=t ;;
 179        --ignore-date)
 180                ignore_date=t ;;
 181        --)
 182                shift; break ;;
 183        *)
 184                usage ;;
 185        esac
 186        shift
 187done
 188
 189# If the dotest directory exists, but we have finished applying all the
 190# patches in them, clear it out.
 191if test -d "$dotest" &&
 192   last=$(cat "$dotest/last") &&
 193   next=$(cat "$dotest/next") &&
 194   test $# != 0 &&
 195   test "$next" -gt "$last"
 196then
 197   rm -fr "$dotest"
 198fi
 199
 200if test -d "$dotest"
 201then
 202        case "$#,$skip$resolved$abort" in
 203        0,*t*)
 204                # Explicit resume command and we do not have file, so
 205                # we are happy.
 206                : ;;
 207        0,)
 208                # No file input but without resume parameters; catch
 209                # user error to feed us a patch from standard input
 210                # when there is already $dotest.  This is somewhat
 211                # unreliable -- stdin could be /dev/null for example
 212                # and the caller did not intend to feed us a patch but
 213                # wanted to continue unattended.
 214                test -t 0
 215                ;;
 216        *)
 217                false
 218                ;;
 219        esac ||
 220        die "previous rebase directory $dotest still exists but mbox given."
 221        resume=yes
 222
 223        case "$skip,$abort" in
 224        t,t)
 225                die "Please make up your mind. --skip or --abort?"
 226                ;;
 227        t,)
 228                git rerere clear
 229                git read-tree --reset -u HEAD HEAD
 230                orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
 231                git reset HEAD
 232                git update-ref ORIG_HEAD $orig_head
 233                ;;
 234        ,t)
 235                if test -f "$dotest/rebasing"
 236                then
 237                        exec git rebase --abort
 238                fi
 239                git rerere clear
 240                test -f "$dotest/dirtyindex" || {
 241                        git read-tree --reset -u HEAD ORIG_HEAD
 242                        git reset ORIG_HEAD
 243                }
 244                rm -fr "$dotest"
 245                exit ;;
 246        esac
 247        rm -f "$dotest/dirtyindex"
 248else
 249        # Make sure we are not given --skip, --resolved, nor --abort
 250        test "$skip$resolved$abort" = "" ||
 251                die "Resolve operation not in progress, we are not resuming."
 252
 253        # Start afresh.
 254        mkdir -p "$dotest" || exit
 255
 256        if test -n "$prefix" && test $# != 0
 257        then
 258                first=t
 259                for arg
 260                do
 261                        test -n "$first" && {
 262                                set x
 263                                first=
 264                        }
 265                        case "$arg" in
 266                        /*)
 267                                set "$@" "$arg" ;;
 268                        *)
 269                                set "$@" "$prefix$arg" ;;
 270                        esac
 271                done
 272                shift
 273        fi
 274        git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
 275                rm -fr "$dotest"
 276                exit 1
 277        }
 278
 279        # -s, -u, -k, --whitespace, -3, -C and -p flags are kept
 280        # for the resuming session after a patch failure.
 281        # -i can and must be given when resuming.
 282        echo " $git_apply_opt" >"$dotest/apply-opt"
 283        echo "$threeway" >"$dotest/threeway"
 284        echo "$sign" >"$dotest/sign"
 285        echo "$utf8" >"$dotest/utf8"
 286        echo "$keep" >"$dotest/keep"
 287        echo 1 >"$dotest/next"
 288        if test -n "$rebasing"
 289        then
 290                : >"$dotest/rebasing"
 291        else
 292                : >"$dotest/applying"
 293                git update-ref ORIG_HEAD HEAD
 294        fi
 295fi
 296
 297case "$resolved" in
 298'')
 299        files=$(git diff-index --cached --name-only HEAD --) || exit
 300        if test "$files"
 301        then
 302                : >"$dotest/dirtyindex"
 303                die "Dirty index: cannot apply patches (dirty: $files)"
 304        fi
 305esac
 306
 307if test "$(cat "$dotest/utf8")" = t
 308then
 309        utf8=-u
 310else
 311        utf8=-n
 312fi
 313if test "$(cat "$dotest/keep")" = t
 314then
 315        keep=-k
 316fi
 317if test "$(cat "$dotest/threeway")" = t
 318then
 319        threeway=t
 320fi
 321git_apply_opt=$(cat "$dotest/apply-opt")
 322if test "$(cat "$dotest/sign")" = t
 323then
 324        SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
 325                        s/>.*/>/
 326                        s/^/Signed-off-by: /'
 327                `
 328else
 329        SIGNOFF=
 330fi
 331
 332last=`cat "$dotest/last"`
 333this=`cat "$dotest/next"`
 334if test "$skip" = t
 335then
 336        this=`expr "$this" + 1`
 337        resume=
 338fi
 339
 340if test "$this" -gt "$last"
 341then
 342        echo Nothing to do.
 343        rm -fr "$dotest"
 344        exit
 345fi
 346
 347while test "$this" -le "$last"
 348do
 349        msgnum=`printf "%0${prec}d" $this`
 350        next=`expr "$this" + 1`
 351        test -f "$dotest/$msgnum" || {
 352                resume=
 353                go_next
 354                continue
 355        }
 356
 357        # If we are not resuming, parse and extract the patch information
 358        # into separate files:
 359        #  - info records the authorship and title
 360        #  - msg is the rest of commit log message
 361        #  - patch is the patch body.
 362        #
 363        # When we are resuming, these files are either already prepared
 364        # by the user, or the user can tell us to do so by --resolved flag.
 365        case "$resume" in
 366        '')
 367                git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
 368                        <"$dotest/$msgnum" >"$dotest/info" ||
 369                        stop_here $this
 370
 371                # skip pine's internal folder data
 372                grep '^Author: Mail System Internal Data$' \
 373                        <"$dotest"/info >/dev/null &&
 374                        go_next && continue
 375
 376                test -s "$dotest/patch" || {
 377                        echo "Patch is empty.  Was it split wrong?"
 378                        stop_here $this
 379                }
 380                if test -f "$dotest/rebasing" &&
 381                        commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
 382                                -e q "$dotest/$msgnum") &&
 383                        test "$(git cat-file -t "$commit")" = commit
 384                then
 385                        git cat-file commit "$commit" |
 386                        sed -e '1,/^$/d' >"$dotest/msg-clean"
 387                else
 388                        SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
 389                        case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
 390
 391                        (printf '%s\n\n' "$SUBJECT"; cat "$dotest/msg") |
 392                                git stripspace > "$dotest/msg-clean"
 393                fi
 394                ;;
 395        esac
 396
 397        GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 398        GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 399        GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 400
 401        if test -z "$GIT_AUTHOR_EMAIL"
 402        then
 403                echo "Patch does not have a valid e-mail address."
 404                stop_here $this
 405        fi
 406
 407        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 408
 409        case "$resume" in
 410        '')
 411            if test '' != "$SIGNOFF"
 412            then
 413                LAST_SIGNED_OFF_BY=`
 414                    sed -ne '/^Signed-off-by: /p' \
 415                    "$dotest/msg-clean" |
 416                    sed -ne '$p'
 417                `
 418                ADD_SIGNOFF=`
 419                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 420                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 421                    echo "$SIGNOFF"
 422                }`
 423            else
 424                ADD_SIGNOFF=
 425            fi
 426            {
 427                if test -s "$dotest/msg-clean"
 428                then
 429                        cat "$dotest/msg-clean"
 430                fi
 431                if test '' != "$ADD_SIGNOFF"
 432                then
 433                        echo "$ADD_SIGNOFF"
 434                fi
 435            } >"$dotest/final-commit"
 436            ;;
 437        *)
 438                case "$resolved$interactive" in
 439                tt)
 440                        # This is used only for interactive view option.
 441                        git diff-index -p --cached HEAD -- >"$dotest/patch"
 442                        ;;
 443                esac
 444        esac
 445
 446        resume=
 447        if test "$interactive" = t
 448        then
 449            test -t 0 ||
 450            die "cannot be interactive without stdin connected to a terminal."
 451            action=again
 452            while test "$action" = again
 453            do
 454                echo "Commit Body is:"
 455                echo "--------------------------"
 456                cat "$dotest/final-commit"
 457                echo "--------------------------"
 458                printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 459                read reply
 460                case "$reply" in
 461                [yY]*) action=yes ;;
 462                [aA]*) action=yes interactive= ;;
 463                [nN]*) action=skip ;;
 464                [eE]*) git_editor "$dotest/final-commit"
 465                       action=again ;;
 466                [vV]*) action=again
 467                       LESS=-S ${PAGER:-less} "$dotest/patch" ;;
 468                *)     action=again ;;
 469                esac
 470            done
 471        else
 472            action=yes
 473        fi
 474        FIRSTLINE=$(sed 1q "$dotest/final-commit")
 475
 476        if test $action = skip
 477        then
 478                go_next
 479                continue
 480        fi
 481
 482        if test -x "$GIT_DIR"/hooks/applypatch-msg
 483        then
 484                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 485                stop_here $this
 486        fi
 487
 488        printf 'Applying: %s\n' "$FIRSTLINE"
 489
 490        case "$resolved" in
 491        '')
 492                eval 'git apply '"$git_apply_opt"' --index "$dotest/patch"'
 493                apply_status=$?
 494                ;;
 495        t)
 496                # Resolved means the user did all the hard work, and
 497                # we do not have to do any patch application.  Just
 498                # trust what the user has in the index file and the
 499                # working tree.
 500                resolved=
 501                git diff-index --quiet --cached HEAD -- && {
 502                        echo "No changes - did you forget to use 'git add'?"
 503                        stop_here_user_resolve $this
 504                }
 505                unmerged=$(git ls-files -u)
 506                if test -n "$unmerged"
 507                then
 508                        echo "You still have unmerged paths in your index"
 509                        echo "did you forget to use 'git add'?"
 510                        stop_here_user_resolve $this
 511                fi
 512                apply_status=0
 513                git rerere
 514                ;;
 515        esac
 516
 517        if test $apply_status = 1 && test "$threeway" = t
 518        then
 519                if (fall_back_3way)
 520                then
 521                    # Applying the patch to an earlier tree and merging the
 522                    # result may have produced the same tree as ours.
 523                    git diff-index --quiet --cached HEAD -- && {
 524                        echo No changes -- Patch already applied.
 525                        go_next
 526                        continue
 527                    }
 528                    # clear apply_status -- we have successfully merged.
 529                    apply_status=0
 530                fi
 531        fi
 532        if test $apply_status != 0
 533        then
 534                printf 'Patch failed at %s %s\n' "$msgnum" "$FIRSTLINE"
 535                stop_here_user_resolve $this
 536        fi
 537
 538        if test -x "$GIT_DIR"/hooks/pre-applypatch
 539        then
 540                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 541        fi
 542
 543        tree=$(git write-tree) &&
 544        parent=$(git rev-parse --verify HEAD) &&
 545        commit=$(
 546                if test -n "$ignore_date"
 547                then
 548                        GIT_AUTHOR_DATE=
 549                fi
 550                if test -n "$committer_date_is_author_date"
 551                then
 552                        GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
 553                        export GIT_COMMITTER_DATE
 554                fi &&
 555                git commit-tree $tree -p $parent <"$dotest/final-commit"
 556        ) &&
 557        git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
 558        stop_here $this
 559
 560        if test -x "$GIT_DIR"/hooks/post-applypatch
 561        then
 562                "$GIT_DIR"/hooks/post-applypatch
 563        fi
 564
 565        go_next
 566done
 567
 568git gc --auto
 569
 570rm -fr "$dotest"